#-*- coding: utf-8 -*-
import numpy as np
import csv
from sklearn.neural_network import BernoulliRBM
import sys
import random
import gc
sys.path.append("./../Util/")

import preparation
import clustering
import evaluation



projectName = ['eclipse','equinox','lucene','mylyn','pde']
metricsName = ['bug-metrics','change-metrics','complexity-code-change','single-version-ck-oo','churn','exp-churn','lin-churn','log-churn','weighted-churn','ent','exp-ent','lin-ent','log-ent','weighted-ent']
OUTPUT_METRICS_NAME = ['bug-metrics','change','complexity','CKandOO','churn','exp-churn','lin-churn','log-churn','weighted-churn','ent','exp-ent','lin-ent','log-ent','weighted-ent']


def data_extend(filename,p_name,times, m_num):
    train_data = []
    train_target = []

    filename2 = "./../../data/AEEEM/{0}/churn/{1}/test_times{2}.csv"
    filename3 = "./../../data/AEEEM/{0}/entropy/{1}/test_times{2}.csv"

    if m_num < 4:
        f = open(filename.format(p_name,metricsName[m_num],times),'r')
    elif m_num < 9:
        f = open(filename2.format(p_name,metricsName[m_num],times),'r')
    else:
        f = open(filename3.format(p_name,metricsName[m_num],times),'r')

    f_bug = open(filename.format(p_name,metricsName[3],times),'r')
    #f_bug = open(filename.format(p_name,'single-version-ck-oo',times),'r')

    dataReader = csv.reader(f)
    dataReader_bug = csv.reader(f_bug)
    for row, row_bug in zip(dataReader, dataReader_bug):

        if m_num==0:
            temp = list(map(float,row[1:6]))
        elif m_num==1:
            temp = list(map(float,row[1:16]))
        elif m_num==2:
            temp = list(map(float,row[1:6]))
        elif m_num==3:
            temp = list(map(float,row[1:18]))
        elif m_num==4:
            temp = list(map(float,row[1:18]))
        elif m_num==5:
            temp = list(map(float,row[1:18]))
        elif m_num==6:
            temp = list(map(float,row[1:18]))
        elif m_num==7:
            temp = list(map(float,row[1:18]))
        elif m_num==8:
            temp = list(map(float,row[1:18]))
        elif m_num==9:
            temp = list(map(float,row[1:18]))
        elif m_num==10:
            temp = list(map(float,row[1:18]))
        elif m_num==11:
            temp = list(map(float,row[1:18]))
        elif m_num==12:
            temp = list(map(float,row[1:18]))
        elif m_num==13:
            temp = list(map(float,row[1:18]))
        else:
            sys.exit()

        train_data.append(temp)
        train_target.append(float(row_bug[18]))


    train_data = np.array(train_data)

    temp = []
    for i in train_target:
        if i != 0:
            temp.append(1)
        else:
            temp.append(0)

    train_target = np.array(temp)

    return [train_data, train_target]


def cal_10_fold_CV_PROMISE(projectName,metricsName,m_num):
    ALL = {}
    ALL['Error of SC'] = []
    ALL['Error of train_data'] = []

    for file_name in projectName:
        ALL[file_name] = []
        count = 0
        all_count = 0

        SC = []
        PAM = []
        NG = []
        FCM = []
        KM = []

        RBM_feature_data_list = []

        components = []
        intercepts_visible = []
        intercepts_hidden = []
        error_list = []
        #for times in range(1,501):
        for _num in range(10):
            times = random.randint(1,100)

            print("+++ {0} times {1} fold +++".format(times,file_name))

            filename = "./../../data/AEEEM/{0}/{1}/test_times{2}.csv"

            train_data = []
            train_target = []

            train_data, train_target = data_extend(filename,file_name,times,m_num)

            if sum(train_target)==0 or sum(train_target)==len(train_target):
                all_count = all_count + 1
                print("---train data error---")
                continue

            test_data = [1,2,3]

            train_data_std = preparation.standardization(train_data,"0-1scale")


            random_state = 200

            #print("--- iter:{0}, times:{1}, data:{2} ---".format(ite,times,file_name))

            for k in range(10,11):
                #print("# feature is {0}".format(k))

                model = BernoulliRBM(n_components=k,random_state=random_state)


                RBM_feature_data = model.fit_transform(train_data_std)

                components.append(model.components_)
                intercepts_hidden.append(model.intercept_hidden_)
                intercepts_visible.append(model.intercept_visible_)
                #print(model.transform(train_data_std))

                #print(RBM_feature_data) 
                #for temp in RBM_feature_data:
                #    print(temp)

                Origin_feature_data = preparation.standardization(train_data,"z-score")
                RBM_feature_data_list.append(RBM_feature_data)


                feature_data_SC = preparation.standardization(RBM_feature_data,"z-score")
                ans = clustering.cslSCbyR(feature_data_SC,RBM=True)

                if ans != 1:

                    temp = evaluation.calAUC(ans,train_target,Origin_feature_data)
                    #print(temp)
                    SC.append(temp)
                else :
                    print("Error")
                    error_list.append([times])


                #RBM_feature_data = model.fit_transform(train_data_std)

                ans = clustering.cslPAMbyR(RBM_feature_data)
                #ans = clustering.cslPAMbyR(train_data)

                #print('RBM with PAM')
                temp = evaluation.calAUC(ans,train_target,Origin_feature_data)
                #print(temp)
                PAM.append(temp)


                ans = clustering.cslNGbyR(RBM_feature_data)

                #print('RBM with NG')
                temp = evaluation.calAUC(ans,train_target,Origin_feature_data)
                #print(temp)
                NG.append(temp)


                #ans = cslSCbyR(train_data_std)
                ans = clustering.cslFCMbyR(RBM_feature_data)

                #print('RBM with FCM')
                temp = evaluation.calAUC(ans,train_target,Origin_feature_data)
                #print(temp)
                FCM.append(temp)


                ans = clustering.cslKMbyR(RBM_feature_data)

                #print('RBM with KM')
                temp = evaluation.calAUC(ans,train_target,Origin_feature_data)
                #print(temp)
                KM.append(temp)

                del train_data
                del train_target
                del train_data_std
                del Origin_feature_data
                del RBM_feature_data
                gc.collect()

        ALL[file_name].append(SC)
        ALL[file_name].append(PAM)
        ALL[file_name].append(NG)
        ALL[file_name].append(FCM)
        ALL[file_name].append(KM)
        ALL['Error of SC'].append(count)
        ALL['Error of train_data'].append(all_count)

        print(" --- result of {0} average --- ".format(file_name))
        try :
            print("SC : {0}".format(sum(ALL[file_name][0])/len(ALL[file_name][0])))
        except ZeroDivisionError:
            print("All SCs were not caluculated by ZeroDivisionError")
        print("PAM : {0}".format(sum(ALL[file_name][1])/len(ALL[file_name][1])))
        print("NG : {0}".format(sum(ALL[file_name][2])/len(ALL[file_name][2])))
        print("FCM : {0}".format(sum(ALL[file_name][3])/len(ALL[file_name][3])))
        print("KM : {0}".format(sum(ALL[file_name][4])/len(ALL[file_name][4])))


        f = open('./data/AEEEM/{0}/SC_Error_{1}.csv'.format(OUTPUT_METRICS_NAME[m_num],file_name),'w')
        csvWriter = csv.writer(f)
        for row in error_list:
            csvWriter.writerow([row])


        f = open('./data/AEEEM/{0}/{1}.csv'.format(OUTPUT_METRICS_NAME[m_num],file_name),'w')
        csvWriter = csv.writer(f)

        for metrics in ALL[file_name]:
            csvWriter.writerow(metrics)


        f = open('./data/AEEEM/{0}/weight_{1}.csv'.format(OUTPUT_METRICS_NAME[m_num],file_name),'w')
        csvWriter = csv.writer(f)

        for count,metrics in enumerate(components):
            csvWriter.writerow("".format(count))
            for row in metrics:
                csvWriter.writerow(row)


        f = open('./data/AEEEM/{0}/intercepts_visible_{1}.csv'.format(OUTPUT_METRICS_NAME[m_num],file_name),'w')
        csvWriter = csv.writer(f)

        for count,metrics in enumerate(intercepts_visible):
            csvWriter.writerow("".format(count))
            csvWriter.writerow(metrics)


        f = open('./data/AEEEM/{0}/intercepts_hidden_{1}.csv'.format(OUTPUT_METRICS_NAME[m_num],file_name),'w')
        csvWriter = csv.writer(f)

        for count,metrics in enumerate(intercepts_hidden):
            csvWriter.writerow("".format(count))
            csvWriter.writerow(metrics)


        f = open('./data/AEEEM/{0}/{1}_metrics.csv'.format(OUTPUT_METRICS_NAME[m_num],file_name),'w')
        csvWriter = csv.writer(f)

        for metrics in RBM_feature_data_list:
            for metric in metrics:
                csvWriter.writerow(metric)

            csvWriter.writerow("")

random.seed(200)
for m_num in range(len(metricsName)):
    cal_10_fold_CV_PROMISE(projectName,metricsName,m_num)


