#!/bin/sh
R --vanilla --slave << 'EOM'

#library(stats)
library(gplots)

models = c('AE','RBM')
metrics = c('CKandOO','bug-metrics','change','complexity','churn','exp-churn','lin-churn','log-churn','weighted-churn','ent','exp-ent','lin-ent','log-ent','weighted-ent')

projects = c('eclipse','equinox','lucene','mylyn','pde')

for(model in models){

    for(metric in metrics){

        for(p_name in projects){

            dat <- read.csv(paste("./heatmap_data/",model,"/",metric,"/",p_name,".csv",sep=""),header=T,check.names=FALSE)
            dat_write <- read.csv(paste("./heatmap_data/",model,"/",metric,"/normal_",p_name,".csv",sep=""),header=T,check.names=FALSE,colClasses=c(rep('character',10)))
            x <- as.matrix(dat)
            rownames(x) <- c('H1','H2','H3','H4','H5','H6','H7','H8','H9','H10')
            bk <- seq(0, 1, by=0.025)
            pdf(paste("./heatmap_plot/",model,"/",metric,"/heatmap_",model,'_',p_name,'_',metric,".pdf",sep=""))
            hv <- heatmap.2(x,Rowv=NA,Colv=NA,scale="none",vline=NA,hline=NA,margins=c(5,5),breaks=bk,
            tracecol=NA,key=FALSE,lhei=c(0.01,3),lwid=c(0.01,3),cexRow=2.5,cexCol=2.5,
            cellnote=dat_write,notecex=1.5,notecol='black')
            dev.off()
        }

    }

}
