import csv
import re
import numpy as np
from scipy.stats import spearmanr
import pandas as pd
import random
import sys
sys.path.append("./../Util/")

import preparation

#CSVName = [['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3'],['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],['eclipse','equinox','lucene','mylyn','pde']]
#PROJECTNAME = ["PROMISE","NASA","AEEEM"]
CSVName = [['eclipse','equinox','lucene','mylyn','pde']]
PROJECTNAME = ["AEEEM"]
#CSVName = [['ant_v1_7']]
#PROJECTNAME = ["PROMISE"]
#FEATURE_REDUCTIONS = ['AutoEnco','FastMap','FeatureAgglomeration','PCA','RandomProjection','RBM']
#FEATURE_REDUCTIONS = ['RBM']
#FEATURE_REDUCTIONS = ['AutoEnco','RBM','RandomProjection','FeatureAgglomeration','FastMap']
#FEATURE_REDUCTIONS = ['TCA','TCA+']
#FEATURE_REDUCTIONS = ['AutoEnco','RBM','RandomProjection','FeatureAgglomeration','FastMap','TCA','TCA+']
FEATURE_REDUCTIONS = ['RBM','AE']
metricsName_RBM = ['H1','H2','H3','H4','H5','H6','H7','H8','H9','H10']
metricsName = ['CKandOO','bug-metrics','change','complexity','churn','exp-churn','lin-churn','log-churn','weighted-churn','ent','exp-ent','lin-ent','log-ent','weighted-ent']

def RBM_data_extend(filename):
    data = []

    f = open(filename,'r')
    dataReader = csv.reader(f)
    temp = []
    for row in dataReader:
        if len(row)==0:
            #temp = preparation.standardization(temp,"z-score")
            data.append(temp)
            temp = []
        else:
            temp.append(list(map(float,row)))

    if len(temp) != 0:
        #temp = preparation.standardization(temp,"z-score")
        data.append(temp)
        print("TEST")

    f.close()

    return data


def data_extend(filename, filename_cv):
    data = []

    f = open(filename,'r')
    f_cv = open(filename_cv,'r')

    dataReader = csv.reader(f)
    dataReader_cv = csv.reader(f_cv)

    num = []
    count = 0
    for row in dataReader_cv:
        if len(row)==0:
            num.append(count)
            count = 0
        else:
            count += 1

    temp = []
    count = 0
    for row in dataReader:
        if num[count]==len(temp):

            #temp = preparation.standardization(temp,"z-score")
            #temp = np.array(temp)
            
            data.append(temp)
            temp = [list(map(float,row))]
            count+=1
        else:
            temp.append(list(map(float,row)))

    if len(temp) != 0:
        #temp = preparation.standardization(temp,"z-score")
        #temp = np.array(temp)
        data.append(temp)
        print("TEST")

    f.close()

    return data


def random_extract_weight(data):

    #print(len(PARAMETERS['weight']))
    
    idx = random.randint(0,len(data)-1)
    
    fold_data = data[idx]

    return fold_data


def cal_main(feature_reduction,csvName,projectName, METRICS):

    for file_name in csvName:

        filename = './../{0}/data/{1}/{2}/{3}_metrics.csv'.format(feature_reduction, projectName, METRICS, file_name)
        #filename_cv = './../RBM/data/{0}/{1}/{2}_metrics.csv'.format(projectName, METRICS, file_name)

        #if feature_reduction!='RBM':
        #    temp_RBMmetrics = data_extend(filename, filename_cv)
        #elif feature_reduction=='RBM':
        temp_RBMmetrics = RBM_data_extend(filename)
        #else:
        #    print('Error')
        #    sys.exit()

        RBMmetrics = []
        for idx in range(10):
            RBMmetrics.extend(temp_RBMmetrics[idx])

        RBMmetrics = preparation.standardization(RBMmetrics,"z-score")
        #print(RBMmetrics)
        #print(len(RBMmetrics))
        #print(len(RBMmetrics[0]))
        RBMmetrics = RBMmetrics.T
        #print(len(RBMmetrics))
        #print(len(RBMmetrics[0]))
        #sys.exit()

        TABLE = []
        TABLE_normal = []
        for idx_1 in range(len(RBMmetrics)):
            row = []
            row_normal = []
            for idx_2 in range(len(RBMmetrics)):

                if idx_1 <= idx_2:
                    #print("{0} vs. {1}".format(metricsName_RBM[idx_1], metricsName_RBM[idx_2]))
                    #row.append(spearmanr(RBMmetrics[idx_1],RBMmetrics[idx_2]))
                    #row.append(spearmanr(RBMmetrics[idx_1],RBMmetrics[idx_2])[0])
                    tmp = abs(spearmanr(RBMmetrics[idx_1],RBMmetrics[idx_2])[0])
                    row.append('%03.3f' % (1-tmp))
                    row_normal.append('%03.3f' % (tmp))
                else:
                    row.append("")
                    row_normal.append("")

            #row[-1] = '{0}\\\\'.format(row[-1])
            TABLE.append(row)
            TABLE_normal.append(row_normal)

        #print(TABLE)
        
        f = open("./heatmap_data/{0}/{1}/{2}.csv".format(feature_reduction, METRICS, file_name),'w')
        csvWriter = csv.writer(f)

        csvWriter.writerow(metricsName_RBM)
        for row in TABLE:
            csvWriter.writerow(row)

        f.close()



        f = open("./heatmap_data/{0}/{1}/normal_{2}.csv".format(feature_reduction, METRICS, file_name),'w')
        csvWriter = csv.writer(f)

        csvWriter.writerow(metricsName_RBM)
        for row in TABLE_normal:
            csvWriter.writerow(row)

        f.close()
        

for METRICS in metricsName:

    for feature_reduction in FEATURE_REDUCTIONS:

        for csvName, projectName in zip(CSVName, PROJECTNAME):
            cal_main(feature_reduction,csvName,projectName, METRICS)
