import tensorflow as tf

H = 10
MINI_BATCH_SIZE = 50
DROP_OUT_RATE = 0.5


def weight_variable(shape):
    """
    truncated_normal -> generating Truncated normal distribution using an argument shape.
    https://en.wikipedia.org/wiki/Truncated_normal_distribution

    shape's format is a taple

    """
    initial = tf.truncated_normal(shape, stddev=0.1)
    return tf.Variable(initial)


def bias_variable(shape):
    """
    shape's format is a list
    """
    initial = tf.constant(0.1, shape=shape)
    return tf.Variable(initial)

def create_minibatch(train_data):

    MINI_BATCH_DATA = []
    temp = []
    for row in train_data:

        if len(temp)<MINI_BATCH_SIZE:
            temp.append(row)

        else:
            MINI_BATCH_DATA.append(temp)
            temp = [row]

    if len(temp) != 0:
        MINI_BATCH_DATA.append(temp)

    return MINI_BATCH_DATA


def AE_SVL(train_data_std,test_data_std,EPOCH=200):

    DATA_SIZE = len(train_data_std[0])

    x = tf.placeholder(tf.float32, [None, DATA_SIZE])

    W = weight_variable((DATA_SIZE, H))
    b1 = bias_variable([H])

    """
    softsign(x) = x / (abs(x)+1)
    """
    #h = tf.nn.softsign(tf.matmul(x,W) + b1)
    h = tf.nn.sigmoid(tf.matmul(x,W) + b1)
    keep_prob = tf.placeholder("float")

    # Define dropout
    h_drop = tf.nn.dropout(h, keep_prob)

    """
    tied weight: W2 is transposed W
    """
    W2 = tf.transpose(W)
    b2 = bias_variable([DATA_SIZE])
    #y = tf.nn.relu(tf.matmul(h_drop, W2) + b2)
    y = tf.nn.sigmoid(tf.matmul(h_drop, W2) + b2)

    # Define Loss Fuction
    loss = tf.nn.l2_loss(y - x) / MINI_BATCH_SIZE

    # For monitoring
    """"""
    #tf.scalar_summary("l2_loss", loss)
    #tf.summary.scalar("l2_loss",loss)
    """"""

    train_step = tf.train.AdamOptimizer().minimize(loss)


    """"""
    #init = tf.initialize_all_variables()
    init = tf.global_variables_initializer()
    """"""

    sess = tf.Session()
    sess.run(init)

    """"""
    #summary_writer = tf.train.SummaryWriter('summary/l2_loss', graph_def=sess.graph_def)
    #summary_writer = tf.summary.FileWriter('summary/l2_loss', graph_def=sess.graph_def)
    """"""


    """
    Training
    """
    #for epoch in range(20000):
    for epoch in range(EPOCH):

        MINI_BATCH_DATA = create_minibatch(train_data_std)
        if len(MINI_BATCH_DATA[-1])==0:
            del MINI_BATCH_DATA[-1]

        for mini_batch_x in MINI_BATCH_DATA:

            sess.run(train_step, feed_dict={x: mini_batch_x, keep_prob: (1-DROP_OUT_RATE)})

            # collect summary
            """ Collection all node's results """
            #summary_op = tf.merge_all_summaries()
            #summary_op = tf.summary.merge_all()
            """"""
            #summary_str = sess.run(summary_op, feed_dict={x: mini_batch_x, keep_prob: 1.0})
            #summary_writer.add_summary(summary_str, epoch)

        # Expressiong values on terminal
        #if epoch % 100 == 0:
        #    print(loss.eval(session=sess, feed_dict={x: mini_batch_x, keep_prob: 1.0}))
        #print(loss.eval(session=sess, feed_dict={x: mini_batch_x, keep_prob: 1.0}))


    ae_metrics_train = h.eval(session=sess,feed_dict={x:train_data_std, keep_prob:1.0})
    ae_metrics_test = h.eval(session=sess,feed_dict={x:test_data_std, keep_prob:1.0})

    weight = sess.run(W)
    bias_input = sess.run(b1)

    return ae_metrics_train, ae_metrics_test, weight.T, bias_input


