import numpy as np

def PCA(train_data_std,threadshold_PCA):

    #print(train_data_std)
    dat_std = np.matrix(train_data_std)

    cov = (dat_std.getT().dot(dat_std))/train_data_std.shape[0]

    U, S, V = np.linalg.svd(cov,full_matrices=True)

    temp = []
    count = 1
    summation = sum(S)
    for i in S:
        temp.append(i)
        #print("%")
        #print(sum(temp[0:count])/sum(temp))
        #print(sum(temp))
        #print(sum(temp))
        th = sum(temp[0:count])/summation
        #print(th)
        if th>threadshold_PCA:
            break
        #print(count)
        count += 1

    k = count

    U_reduce = U[:,0:k]
    #print(U_reduce)

    m = train_data_std.shape[0]

    Z = np.zeros((m,k))

    count = 0
    for i in dat_std:
        projection_k = i.dot(U_reduce)
        Z[count,:] = projection_k
        count = count + 1

    #print(Z)

    #for i in Z:
    #    recovered_j = i.dot(U_reduce.getT())
    #    print(recovered_j)

    return Z


"""
In SVL, we refer neumann2002TSE paper (An enhanced neural network technique for software risk analysis).
They also use PCA in SVL situation.
"""
def PCA_SVL(train_data_std,test_data_std,threadshold_PCA):

    train_matrix_std = np.matrix(train_data_std)
    test_matrix_std = np.matrix(test_data_std)

    cov = (train_matrix_std.getT().dot(train_matrix_std))/train_data_std.shape[0]

    U, S, V = np.linalg.svd(cov,full_matrices=True)

    temp = []
    count = 1
    summation = sum(S)
    for i in S:
        temp.append(i)
        #print("%")
        #print(sum(temp[0:count])/sum(temp))
        #print(sum(temp))
        #print(sum(temp))
        th = sum(temp[0:count])/summation
        #print(th)
        if th>threadshold_PCA:
            break
        #print(count)
        count += 1

    k = count

    U_reduce = U[:,0:k]
    #print(U_reduce)

    m = train_data_std.shape[0]
    train_Z = np.zeros((m,k))

    m = test_data_std.shape[0]
    test_Z = np.zeros((m,k))

    count = 0
    for i,j in zip(train_matrix_std,test_matrix_std):
        projection_k = i.dot(U_reduce)
        train_Z[count,:] = projection_k

        projection_k = j.dot(U_reduce)
        test_Z[count,:] = projection_k

        count = count + 1

    #print(train_Z)

    #for i in train_Z:
    #    recovered_j = i.dot(U_reduce.getT())
    #    print(recovered_j)

    return train_Z, test_Z
