
import csv
import numpy as np


csvName1 = ['bug-metrics','change-metrics','complexity-code-change','single-version-ck-oo']

directoryName2 = 'churn'
csvName2 = ['churn','exp-churn','lin-churn','log-churn','weighted-churn']

directoryName3 = 'entropy'
csvName3 = ['ent','exp-ent','lin-ent','log-ent','weighted-ent']


def bootstrap(p_name, times, seed):
    np.random.seed(seed)
    entities = 692

    idx = np.random.randint(entities-1, size=entities-1)
    test_idx = np.array(list(set([x for x in range(entities-1)]) - set(idx)))

    idx = idx + 1
    test_idx = test_idx + 1
        
    # first
    for c_name in csvName1:
        reader = csv.reader(open('./../../data/original_data/{0}/{1}.csv'.format(p_name,c_name)))
        data = []
        for row in reader :
            data.append(row)

        data = np.array(data)
        f = open('./tmp/AEEEM_train_{0}_{1}_times{2}.csv'.format(p_name,c_name,times),'w')
        writer = csv.writer(f)
        for row in data[idx]:
            writer.writerow(row)
        f.close()

        f = open('./tmp/AEEEM_test_{0}_{1}_times{2}.csv'.format(p_name,c_name,times),'w')
        writer = csv.writer(f)
        for row in data[test_idx]:
            writer.writerow(row)
        f.close()


    # about churn
    for c_name in csvName2:
        reader = csv.reader(open('./../../data/original_data/{0}/{2}/{1}.csv'.format(p_name,c_name,directoryName2)))

        data = []
        for row in reader :
            data.append(row)

        data = np.array(data)
        f = open('./tmp/AEEEM_train_{0}_{1}_{2}_times{3}.csv'.format(p_name,directoryName2,c_name,times),'w')
        writer = csv.writer(f)
        for row in data[idx]:
            writer.writerow(row)
        f.close()

        f = open('./tmp/AEEEM_test_{0}_{1}_{2}_times{3}.csv'.format(p_name,directoryName2,c_name,times),'w')
        writer = csv.writer(f)
        for row in data[test_idx]:
            writer.writerow(row)
        f.close()


    # entropy

    for c_name in csvName3:
        reader = csv.reader(open('./../../data/original_data/{0}/{2}/{1}.csv'.format(p_name,c_name,directoryName3)))

        data = []
        for row in reader :
            data.append(row)

        data = np.array(data)
        f = open('./tmp/AEEEM_train_{0}_{1}_{2}_times{3}.csv'.format(p_name,directoryName3,c_name,times),'w')
        writer = csv.writer(f)
        for row in data[idx]:
            writer.writerow(row)
        f.close()

        f = open('./tmp/AEEEM_test_{0}_{1}_{2}_times{3}.csv'.format(p_name,directoryName3,c_name,times),'w')
        writer = csv.writer(f)
        for row in data[test_idx]:
            writer.writerow(row)
        f.close()


