#-*- coding: utf-8 -*-
import pyper
import numpy as np
import sys

# After that, the function calculated SVL situations.

import evaluation


random_state = 200


# ref:https://github.com/topepo/caret/blob/master/RegressionTests/Code/J48.R
def Caret(train_data_std, train_target, test_data_std,test_target,r):


    r.assign("train_data",train_data_std)
    r.assign("train_target",train_target)
    r.assign("test_data",test_data_std)
    r.assign("test_target",test_target)

    r('cctrl <- trainControl(method = "cv", number = 3, classProbs = TRUE, summaryFunction = twoClassSummary)')

    r('temp <- c(train_target==1)')
    r('temp <- gsub(TRUE,"Class1",temp)')
    r('temp <- gsub(FALSE,"Class2",temp)')
    r('train_target <- as.factor(temp)')

    r('train_data=as.data.frame(train_data)')
    r('train_data=cbind(train_data,train_target)')
    

    r('model <- train(train_target~.,data=train_data,method="LMT",trControl=cctrl,metric="ROC")')
    r('pred <- predict(model,test_data,type="prob")')

    ans_LMT = np.array(r.get("pred"))
    ans_LMT = np.array(list(map(list,ans_LMT)))

    r('pred = NaN')
    r('model = NaN')


    #print("test")
    r('model <- train(train_target~.,data=train_data,method="J48",trControl=cctrl,metric="ROC")')
    r('pred <- predict(model,test_data,type="prob")')
    
    ans_J48 = np.array(r.get("pred"))
    ans_J48 = np.array(list(map(list,ans_J48)))

    r('pred = NaN')
    r('model = NaN')


    #print("test")
    r('model <- train(train_target~.,data=train_data,method="nb",trControl=cctrl,metric="ROC")')
    r('pred <- predict(model,test_data,type="prob")')
    
    ans_NB = np.array(r.get("pred"))
    ans_NB = np.array(list(map(list,ans_NB)))

    r('pred = NaN')
    r('model = NaN')


    #print("test")
    r('model <- train(train_target~.,data=train_data,method="ranger",trControl=cctrl,metric="ROC")')
    r('pred <- predict(model,test_data,type="prob")')
    
    ans_RF = np.array(r.get("pred"))
    ans_RF = np.array(list(map(list,ans_RF)))

    r('pred = NaN')
    r('model = NaN')


    #print("test")
    r('model <- train(train_target~.,data=train_data,method="glm",family=binomial,trControl=cctrl,metric="ROC")')
    r('pred <- predict(model,test_data,type="prob")')
    
    ans_LR = np.array(r.get("pred"))
    ans_LR = np.array(list(map(list,ans_LR)))

    r('pred = NaN')
    r('model = NaN')

    #print(ans_LR[:,0])

    return ans_LMT[:,0],ans_J48[:,0],ans_NB[:,0],ans_RF[:,0],ans_LR[:,0]



