
import csv
import numpy as np



# ===============================
# x: the original data (list, int, array)
# samples: the number of extracted data
# ===============================
def bootstrap(data, samples):

    idx = np.random.randint(data.shape[0], size=samples)
    test_idx = np.array(list(set([x for x in range(data.shape[0])]) - set(idx)))

    resampled_data = data[idx, :]
    test_data = data[test_idx, :]

    return resampled_data, test_data


def new_bootstrap(p_name, times, seed):

    np.random.seed(seed)
    reader = csv.reader(open('./../../data/original_data/{0}.csv'.format(p_name)))

    data = []
    for i in reader :
        data.append(i)

    data = np.array(data)

    resampled_data, test_data = bootstrap(data, data.shape[0])
    #print(resampled_data[0])


    f = open('./tmp/train_{0}_times{1}.csv'.format(p_name,times),'w')
    writer = csv.writer(f)
    for row in resampled_data:
        writer.writerow(row)
    f.close()

    f = open('./tmp/test_{0}_times{1}.csv'.format(p_name,times),'w')
    writer = csv.writer(f)
    for row in test_data:
        writer.writerow(row)
    f.close()

