#-*- coding: utf-8 -*-
import pyper
import numpy as np
import sys

def cslSCbyR(metrics,RBM):

    r = pyper.R()
    r("set.seed(200)")

    if RBM == True:
        r("source('./../Util/RBM_SC.R')")
    elif RBM==False:
        r("source('./../Util/SC.R')")
    else:
        print("ERROR:clustering.py")
        sys.exit()

    r.assign("metrics",metrics)
    r("ans <- spectral_clustering_based_classifier(metrics)")
    temp = np.array(r.get("ans"))
    #print(temp)
    ans = []
    try :
        for i in temp:
            if i==True:
                ans.append(1)
            elif i==False:
                ans.append(0)
            else :
                print('Error')
    except TypeError:
        if RBM == True:
            r("source('./../Util/RBM_SC2.R')")
        elif RBM==False:
            r("source('./../Util/SC2.R')")
        else:
            print("ERROR:clustering.py")
            sys.exit()

        r.assign("metrics",metrics)
        r("ans <- spectral_clustering_based_classifier(metrics)")
        temp = np.array(r.get("ans"))
        ans = []
        try :
            for i in temp:
                if i==1:
                    ans.append(1)
                elif i==2:
                    ans.append(0)
                else :
                    print('Error')
        except TypeError:
            print('TypeError happened,0-d array')
            print('temp is {0}'.format(temp))
            return 1

    return ans


# https://stat.ethz.ch/R-manual/R-devel/library/cluster/html/pam.object.html
def cslPAMbyR(metrics):

    r = pyper.R()
    r("set.seed(200)")

    r("library(cluster)")
    r.assign("metrics",metrics)
    r("ans <- pam(metrics,k=2)")
    temp = np.array(r.get("ans$clustering"))
    ans = []
    for i in temp:
        if i==2:
            ans.append(1)
        elif i==1:
            ans.append(0)
        else :
            print('Error')

    return ans


# https://cran.r-project.org/web/packages/cclust/cclust.pdf
def cslNGbyR(metrics):

    r = pyper.R()
    r("set.seed(200)")

    r("library(cclust)")
    r.assign("metrics",metrics)
    r("ans <- cclust(metrics,centers=2,method='neuralgas')")
    temp = np.array(r.get("ans$cluster"))
    ans = []
    for i in temp:
        if i==2:
            ans.append(1)
        elif i==1:
            ans.append(0)
        else :
            print('Error')

    return ans


# http://ugrad.stat.ubc.ca/R/library/e1071/html/cmeans.html
def cslFCMbyR(metrics):

    r = pyper.R()
    r("set.seed(200)")

    r("library(e1071)")
    r.assign("metrics",metrics)
    r("ans <- cmeans(metrics,centers=2,method='cmeans')")
    temp = np.array(r.get("ans$cluster"))
    ans = []
    for i in temp:
        if i==2:
            ans.append(1)
        elif i==1:
            ans.append(0)
        else :
            print('Error')

    return ans


# https://cran.r-project.org/web/packages/cclust/cclust.pdf
def cslKMbyR(metrics):

    r = pyper.R()
    r("set.seed(200)")

    r("library(cclust)")
    r.assign("metrics",metrics)
    r("ans <- cclust(metrics,centers=2,method='kmeans')")
    temp = np.array(r.get("ans$cluster"))
    ans = []
    for i in temp:
        if i==2:
            ans.append(1)
        elif i==1:
            ans.append(0)
        else :
            print('Error')

    return ans

