import numpy as np
import csv

#csvName = ['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3']
#projectName = "PROMISE"
#CSVName = [['ant_v1_7']]
#PROJECTName = ["PROMISE"]

#CSVName = [['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],['eclipse','equinox','lucene','mylyn','pde']]
#PROJECTName = ['NASA','AEEEM']

#CSVName = [['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3'],['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],['eclipse','equinox','lucene','mylyn','pde']]
#PROJECTName = ['PROMISE','NASA','AEEEM']
CSVName = [['jm1']]
PROJECTName = ['NASA']

metricsName = ['SC','PAM','NG','FCM','KM']

#reductionName =["RBM", "AutoEnco", "FastMap", "FeatureAgglomeration", "PCA", "PRE", "RandomProjection", "TCA", "TCA+"]
reductionName =["AutoEnco", "FastMap", "FeatureAgglomeration", "RandomProjection", "TCA", "TCA+"]
#reductionName =["AutoEnco"]
#reductionName =["FastMap"]

def extract_parameters(f_name,projectName,r_name):

    PARAMETERS = {}


    if r_name in ['RBM', 'AutoEnco']:

        parameter = 'weight'
        PARAMETERS[parameter] = []
        
        times1 = 1
        times2 = 31
        for ite in range(2):
            f = open("./{5}/data/{0}/{1}_{2}_{3}_{4}.csv".format(projectName, parameter, f_name, times1, times2, r_name))

            reader = csv.reader(f)
            header = next(reader)

            temp = []
            for row in reader:
                if len(row)==0:
                    PARAMETERS[parameter].append(np.array(temp))
                    temp = []
                else:
                    #PARAMETERS[parameter].append(list(map(float,row)))
                    temp.append(list(map(float,row)))
            PARAMETERS[parameter].append(temp)

            times1 = times1 + 30
            times2 = times2 + 30

        times1 = 61
        times2 = 101
        f = open("./{5}/data/{0}/{1}_{2}_{3}_{4}.csv".format(projectName, parameter, f_name, times1, times2, r_name))

        reader = csv.reader(f)
        header = next(reader)

        temp = []
        for row in reader:
            if len(row)==0:
                PARAMETERS[parameter].append(np.array(temp))
                temp = []
            else:
                #PARAMETERS[parameter].append(list(map(float,row)))
                temp.append(list(map(float,row)))
        PARAMETERS[parameter].append(temp)





    parameter = 'AUC'
    PARAMETERS[parameter] = {}
    for m_name in metricsName:
        PARAMETERS[parameter][m_name] = []

    times1 = 1
    times2 = 31
    for ite in range(2):
        f = open("./{4}/data/{0}/{1}_{2}_{3}.csv".format(projectName, f_name, times1, times2, r_name))
        reader = csv.reader(f)

        for row, m_name in zip(reader, metricsName):
            PARAMETERS[parameter][m_name].extend(row)

        times1 = times1 + 30
        times2 = times2 + 30


    times1 = 61
    times2 = 101
    f = open("./{4}/data/{0}/{1}_{2}_{3}.csv".format(projectName, f_name, times1, times2, r_name))
    reader = csv.reader(f)

    for row, m_name in zip(reader, metricsName):
        PARAMETERS[parameter][m_name].extend(row)





    parameter = 'metrics'
    PARAMETERS[parameter] = []

    times1 = 1
    times2 = 31
    for ite in range(2):
        f = open("./{4}/data/{0}/{1}_metrics_{2}_{3}.csv".format(projectName, f_name, times1, times2, r_name))
        reader = csv.reader(f)

        for row in reader:
            if len(row)==0:
                continue
            PARAMETERS[parameter].append(row)

        times1 = times1 + 30
        times2 = times2 + 30

    times1 = 61
    times2 = 101
    f = open("./{4}/data/{0}/{1}_metrics_{2}_{3}.csv".format(projectName, f_name, times1, times2, r_name))
    reader = csv.reader(f)

    for row in reader:
        if len(row)==0:
            continue
        PARAMETERS[parameter].append(row)



    return PARAMETERS




if __name__=="__main__":

    for r_name in reductionName:

        for csvName, projectName in zip(CSVName,PROJECTName):
            for file_name in csvName:
                PARAMETERS = extract_parameters(file_name,projectName,r_name)
                #print(PARAMETERS['AUC'])

                f = open('./{2}/data/{0}/{1}_1_101.csv'.format(projectName,file_name, r_name),'w')
                csvWriter = csv.writer(f)

                for m_name in metricsName:
                    csvWriter.writerow(PARAMETERS['AUC'][m_name])


                f = open('./{2}/data/{0}/{1}_metrics_1_101.csv'.format(projectName,file_name, r_name),'w')
                csvWriter = csv.writer(f)

                for row in PARAMETERS['metrics']:
                    csvWriter.writerow(row)

                
                if r_name in ['RBM', 'AutoEnco']:

                    f = open('./{2}/data/{0}/weight_{1}_1_101.csv'.format(projectName,file_name, r_name),'w')
                    csvWriter = csv.writer(f)

                    for count,metrics in enumerate(PARAMETERS['weight']):
                        csvWriter.writerow("".format(count))
                        for row in metrics:
                            csvWriter.writerow(row)

