#-*- coding: utf-8 -*-
import numpy as np
import csv
import random
import pyper
import sys
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
from sklearn.cluster import KMeans
sys.path.append("./../Util/")

import preparation



N_METRICS = 10

CSVName = [['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3'],['eclipse','equinox','lucene','mylyn','pde']]
#CSVName = [['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5']]

#N_PROJECTS = 10
#N_PROJECTS = 11
#N_PROJECTS = 5

PROJECTNAME = ["PROMISE","AEEEM"]
#PROJECTNAME = ["NASA"]

#FEATURE_REDUCTIONS = ['AutoEnco','RBM','RandomProjection','FeatureAgglomeration','FastMap','TCA','TCA+']
#FEATURE_REDUCTIONS = ['AutoEnco','RBM','FeatureAgglomeration']
#FEATURE_REDUCTIONS = ['PCA']
#FEATURE_REDUCTIONS = ['AutoEnco','RBM','PCA']
FEATURE_REDUCTIONS = ['AutoEnco','RBM']


def check_same_feature_across_project(pred):

    project = []

    for i in range(N_METRICS):
        project.append(pred[i])

    value = []
    flag = 0
    for i in pred:
        value.append(i)

        if len(value)==N_METRICS:
            if value!=project:
                flag = 1
            value = []

    if flag==0:
        print("Make the same metrics set across project")
    else:
        print("Make different metrics set across project")


def extract_parameters(feature_reduction,f_name,projectName):


    PARAMETERS = {}

    parameter = 'weight'
    PARAMETERS[parameter] = []
    if feature_reduction=='RBM':
        f = open("./../{0}/data/{1}/{2}_{3}_1_100.csv".format(feature_reduction,projectName, parameter, f_name))
    else:
        f = open("./../{0}/data/{1}/{2}_{3}_1_101.csv".format(feature_reduction,projectName, parameter, f_name))
    #f = open("./../../exp35/USVLwithRBM/data/{0}/{1}_{2}.csv".format(projectName, parameter, f_name))
    #print("./../../exp35/USVLwithRBM/data/{0}/{1}_{2}.csv".format(projectName, parameter, f_name))

    reader = csv.reader(f)
    header = next(reader)

    temp = []
    for row in reader:
        if len(row)==0:
            PARAMETERS[parameter].append(np.array(temp))
            #PARAMETERS[parameter].append(temp)
            temp = []
        else:
            #PARAMETERS[parameter].append(list(map(float,row)))
            if len(temp)<N_METRICS:
                temp.append(list(map(float,row)))
            else:
                pass
    PARAMETERS[parameter].append(temp)

    return PARAMETERS



def random_extract_weight(PARAMETERS, weight_dic, file_name):

    #print(len(PARAMETERS['weight']))
    
    idx = random.randint(0,len(PARAMETERS['weight'])-1)
    
    weight_dic[file_name] = PARAMETERS['weight'][idx]
    #print(idx)
    print(len(PARAMETERS['weight'][idx]))
    print(len(PARAMETERS['weight'][idx][0]))

    return weight_dic


def set_color(l):
    if l == 0:
        return "b"  # blue
    elif l == 1:
        return "g"  # green
    else:
        return "r"  # red


def create_project_marker(projectName):

    if projectName == 'PROMISE':
        markers = ['o', 'v', '^', '<', '>', '8', 's', 'p', '*', 'h']
    elif projectName == 'NASA':
        markers = ['o', 'v', '^', '<', '>', '8', 's', 'p', '*', 'h','+']
    elif projectName == 'AEEEM':
        markers = ['o', 's', 'p', '*', '+']
    else:
        sys.exit()

    return markers


def trans_pred_color(pred,projectName):

    #if projectName == 'PROMISE':
    #    colors = ['black','silver','red','sandybrown','lawngreen','g','skyblue','blue','plum','pink']
    #elif projectName == 'NASA':
    #    colors = ['black','silver','red','sandybrown','lawngreen','g','skyblue','blue','plum','pink','darkred']
    #elif projectName == 'AEEEM':
    #    colors = ['black','silver','red','sandybrown','lawngreen']
    #else:
    #    sys.exit()
    colors = ['black','silver','red','sandybrown','lawngreen','g','skyblue','blue','plum','pink']

    color_list = []
    for num in pred:
        color_list.append(colors[num])

    return color_list


def SNE(data,projectName):


    r = pyper.R()
    r("set.seed(200)")

    r('library(Rtsne)')

    r.assign("dat",data)
    if projectName!='AEEEM':
        r("ans <- Rtsne(dat,perplexity=10,check_duplicates=FALSE,theta=0)")
    else:
        r("ans <- Rtsne(dat,perplexity=10,check_duplicates=FALSE,theta=0)")


    ans = r.get('ans$Y')

    #print(ans)
    return ans


def legend_color_patches(projectName):

    patches = []
    if projectName == 'PROMISE':
        colors = ['black','silver','red','sandybrown','lawngreen','g','skyblue','blue','plum','pink']
        shapes = ['o', 'v', '^', '<', '>', '8', 's', 'p', '*', 'h']
        projects = ['Ant v1.7','Camel v1.6','Ivy v1.4','Jedit v4.0','Log4j v1.0','Lucene v2.4','POI v3.0','Tomcat v6.0','Xalan v2.6','Xerces v1.3']
        classes = ['Cluster {0}'.format(i) for i in range(1,11)]
    elif projectName == 'NASA':
        colors = ['black','silver','red','sandybrown','lawngreen','g','skyblue','blue','plum','pink','darkred']
        shapes = ['o', 'v', '^', '<', '>', '8', 's', 'p', '*', 'h','+']
        projects = ['CM1','JM1','KC3','MC1','MC2','MW1','PC1','PC2','PC3','PC4','PC5']
        classes = ['Cluster {0}'.format(i) for i in range(1,12)]
    elif projectName == 'AEEEM':
        colors = ['black','silver','red','sandybrown','lawngreen']
        shapes = ['o', '8', 'p', '*', '+']
        projects = ['Eclipse JDT Core','Equinox','Apache Lucene','Mylyn','Eclipse PDF UI']
        classes = ['Cluster {0}'.format(i) for i in range(1,6)]
    else:
        sys.exit()

    for c_name,p_name in zip(colors,classes):
        patch = mpatches.Patch(color=c_name,label=p_name)
        patches.append(patch)

    for s_name, c_name in zip(shapes,projects):
        patch = plt.scatter([],[],color='black',marker=s_name,label=c_name)
        patches.append(patch)


    return patches


def cal_10_fold_CV_PROMISE(feature_reduction,csvName,projectName, num):


    weight_dic = {}
    for file_name in csvName:

        PARAMETERS = extract_parameters(feature_reduction, file_name, projectName)

        weight_dic = random_extract_weight(PARAMETERS, weight_dic, file_name)

        weight_dic[file_name] = preparation.standardization(weight_dic[file_name],"z-score")


    dat = []
    for file_name in csvName:

        dat.extend(weight_dic[file_name])


    #pred = KMeans(n_clusters=N_PROJECTS).fit_predict(dat)
    pred = KMeans(n_clusters=N_METRICS).fit_predict(dat)
    #print(pred)
    check_same_feature_across_project(pred)

    #color_list = pred
    #color_list = create_project_color()
    color_list = trans_pred_color(pred,projectName)

    marker_list = create_project_marker(projectName)
    #marker_list = create_project_color()

    
    plt.figure(figsize=(10,7))

    dat = np.array(dat)
    ans = SNE(dat,projectName)


    #plt.scatter([i[0] for i in ans],[i[1] for i in ans],c=color_list)

    value1 = []
    value2 = []
    ini_cnt = 0
    end_cnt = N_METRICS
    flag = 0

    for values in ans:

        value1.append(values[0])
        value2.append(values[1])

        if len(value1)==N_METRICS and len(value2)==N_METRICS:
            #plt.scatter(value1,value2,s=50,c=color_list[ini_cnt:end_cnt],marker = marker_list[flag])
            plt.scatter(value1,value2,s=50,c=color_list[ini_cnt:end_cnt],marker = marker_list[flag],label='{0}'.format(flag+1))
            #print(color_list[ini_cnt:end_cnt])
            value1 = []
            value2 = []
            ini_cnt = ini_cnt + N_METRICS
            end_cnt = end_cnt + N_METRICS
            flag = flag + 1

    patches = legend_color_patches(projectName)

    #plt.title("t-SNE visualization of RBM network coefficients (not z-score)")
    #if projectName=="AEEEM":
    #    plt.title("t-SNE visualization of {0} network coefficients (z-score),\n color indicates k-means (# of centers 10) clusters, shape indicates projects.".format(feature_reduction))
    #elif projectName=="PROMISE":
    #    plt.title("t-SNE visualization of {0} network coefficients (z-score),\n color indicates k-means (# of centers 10) clusters, shape indicates projects.".format(feature_reduction))
    #elif projectName=="NASA":
    #    plt.title("t-SNE visualization of {0} network coefficients (z-score),\n color indicates k-means (# of centers 10) clusters, shape indicates projects.".format(feature_reduction))
    plt.xlabel("t-SNE feature1")
    plt.ylabel("t-SNE feature2")
    plt.rcParams['font.size'] = 20

    #plt.savefig("./plot/" + "non_z-score" + ".pdf")
    #plt.savefig("./plot/" + "z-score" + ".pdf")
    plt.savefig("./clustering_plot/" + feature_reduction + "_" + projectName + "_{0}".format(num) + ".pdf")
    plt.savefig("./clustering_plot/" + feature_reduction + "_" + projectName + "_{0}".format(num) + ".png")



random.seed(200)

for num in range(10):
    for feature_reduction in FEATURE_REDUCTIONS:

        print(feature_reduction)
        for csvName, projectName in zip(CSVName, PROJECTNAME):

            cal_10_fold_CV_PROMISE(feature_reduction, csvName,projectName, num)

