#!/bin/sh
R --vanilla --slave << 'EOM'

#library(stats)
library(gplots)

#models = c('AutoEnco','RBM','RandomProjection','FeatureAgglomeration','FastMap','TCA','TCA+')
models = c('AutoEnco','RBM','FeatureAgglomeration')

#projects = c('ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3')
projects = c('ant_v1_7','camel_v1_6','log4j_v1_0')
for(model in models){

    for(p_name in projects){

        dat <- read.csv(paste("./heatmap_data/",model,"/PROMISE/",p_name,".csv",sep=""),header=T,check.names=FALSE)
        dat_write <- read.csv(paste("./heatmap_data/",model,"/PROMISE/normal_",p_name,".csv",sep=""),header=T,check.names=FALSE,colClasses=c(rep('character',10)))
        x <- as.matrix(dat)
        rownames(x) <- c('H1','H2','H3','H4','H5','H6','H7','H8','H9','H10')
        bk <- seq(0, 1, by=0.025)
        pdf(paste("./heatmap_plot/",model,"/PROMISE/heatmap_",model,'_',p_name,".pdf",sep=""))
        hv <- heatmap.2(x,Rowv=NA,Colv=NA,scale="none",vline=NA,hline=NA,margins=c(5,5),breaks=bk,
        tracecol=NA,key=FALSE,lhei=c(0.01,5),lwid=c(0.01,5),cexRow=2.5,cexCol=2.5,
        cellnote=dat_write,notecex=1.5,notecol='black')
        dev.off()

    }

}

#projects = c('cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5')
projects = c('cm1')
for(model in models){

    for(p_name in projects){

        dat <- read.csv(paste("./heatmap_data/",model,"/NASA/",p_name,".csv",sep=""),header=T,check.names=FALSE)
        dat_write <- read.csv(paste("./heatmap_data/",model,"/NASA/normal_",p_name,".csv",sep=""),header=T,check.names=FALSE,colClasses=c(rep('character',10)))
        x <- as.matrix(dat)
        rownames(x) <- c('H1','H2','H3','H4','H5','H6','H7','H8','H9','H10')
        bk <- seq(0, 1, by=0.025)
        pdf(paste("./heatmap_plot/",model,"/NASA/heatmap_",model,'_',p_name,".pdf",sep=""))
        hv <- heatmap.2(x,Rowv=NA,Colv=NA,scale="none",vline=NA,hline=NA,margins=c(5,5),breaks=bk,
        tracecol=NA,key=FALSE,lhei=c(0.01,5),lwid=c(0.01,5),cexRow=2.5,cexCol=2.5,
        cellnote=dat_write,notecex=1.5,notecol='black')
        dev.off()

    }

}


#projects = c('eclipse','equinox','lucene','mylyn','pde')
projects = c('eclipse')
for(model in models){

    for(p_name in projects){

        dat <- read.csv(paste("./heatmap_data/",model,"/AEEEM/",p_name,".csv",sep=""),header=T,check.names=FALSE)
        dat_write <- read.csv(paste("./heatmap_data/",model,"/AEEEM/normal_",p_name,".csv",sep=""),header=T,check.names=FALSE,colClasses=c(rep('character',10)))
        x <- as.matrix(dat)
        rownames(x) <- c('H1','H2','H3','H4','H5','H6','H7','H8','H9','H10')
        bk <- seq(0, 1, by=0.025)
        pdf(paste("./heatmap_plot/",model,"/AEEEM/heatmap_",model,'_',p_name,".pdf",sep=""))
        hv <- heatmap.2(x,Rowv=NA,Colv=NA,scale="none",vline=NA,hline=NA,margins=c(5,5),breaks=bk,
        tracecol=NA,key=FALSE,lhei=c(0.01,5),lwid=c(0.01,5),cexRow=2.5,cexCol=2.5,
        cellnote=dat_write,notecex=1.5,notecol='black')
        dev.off()

    }

}

EOM
