import csv
import re
import numpy as np
from scipy.stats import spearmanr
import pandas as pd
import random
import sys
sys.path.append("./../Util/")

import preparation

#CSVName = [['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3'],['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],['eclipse','equinox','lucene','mylyn','pde']]
#PROJECTNAME = ["PROMISE","NASA","AEEEM"]
#FEATURE_REDUCTIONS = ['AutoEnco','RBM','RandomProjection','FeatureAgglomeration','FastMap','TCA','TCA+']

CSVName = [['ant_v1_7','camel_v1_6','log4j_v1_0'],['cm1'],['eclipse']]
PROJECTNAME = ["PROMISE","NASA","AEEEM"]
FEATURE_REDUCTIONS = ['AutoEnco','RBM','FeatureAgglomeration']


metricsName_RBM = ['H1','H2','H3','H4','H5','H6','H7','H8','H9','H10']

def RBM_data_extend(filename):
    data = []

    f = open(filename,'r')
    dataReader = csv.reader(f)
    temp = []
    for row in dataReader:
        if len(row)==0:
            #temp = preparation.standardization(temp,"z-score")
            data.append(temp)
            temp = []
        else:
            temp.append(list(map(float,row)))

    if len(temp) != 0:
        #temp = preparation.standardization(temp,"z-score")
        data.append(temp)
        #print("TEST")

    f.close()

    return data



def random_extract_weight(data):

    #print(len(PARAMETERS['weight']))
    
    idx = random.randint(0,len(data)-1)
    
    fold_data = data[idx]

    return fold_data


def cal_main(feature_reduction,csvName,projectName):

    for file_name in csvName:

        if feature_reduction in ['RBM']:
            filename = './../{0}/data/{1}/{2}_metrics_1_100.csv'.format(feature_reduction, projectName, file_name)
        else:
            filename = './../{0}/data/{1}/{2}_metrics_1_101.csv'.format(feature_reduction, projectName, file_name)

        temp_RBMmetrics = RBM_data_extend(filename)

        RBMmetrics = []
        for n in range(10):
            RBMmetrics.extend(random_extract_weight(temp_RBMmetrics))

        RBMmetrics = preparation.standardization(RBMmetrics,"z-score")
        #print(RBMmetrics)
        #print(len(RBMmetrics))
        #print(len(RBMmetrics[0]))
        RBMmetrics = RBMmetrics.T
        #print(len(RBMmetrics))
        #print(len(RBMmetrics[0]))
        #sys.exit()

        TABLE = []
        TABLE_normal = []
        for idx_1 in range(len(RBMmetrics)):
            row = []
            row_normal = []
            for idx_2 in range(len(RBMmetrics)):

                if idx_1 <= idx_2:
                    #print("{0} vs. {1}".format(metricsName_RBM[idx_1], metricsName_RBM[idx_2]))
                    #row.append(spearmanr(RBMmetrics[idx_1],RBMmetrics[idx_2]))
                    #row.append(spearmanr(RBMmetrics[idx_1],RBMmetrics[idx_2])[0])
                    tmp = abs(spearmanr(RBMmetrics[idx_1],RBMmetrics[idx_2])[0])
                    row.append('%03.3f' % (1-tmp))
                    row_normal.append('%03.3f' % (tmp))
                else:
                    row.append("")
                    row_normal.append("")

            #row[-1] = '{0}\\\\'.format(row[-1])
            TABLE.append(row)
            TABLE_normal.append(row_normal)

        #print(TABLE)
        
        #TABLE = pd.DataFrame(TABLE,index=metricsName_RBM,columns=metricsName_RBM)
        #TABLE.to_csv(path_or_buf="./heatmap_data/{0}/{1}/{2}.csv".format(feature_reduction, projectName, file_name),sep=",")

        f = open("./heatmap_data/{0}/{1}/{2}.csv".format(feature_reduction, projectName, file_name),'w')
        csvWriter = csv.writer(f)

        csvWriter.writerow(metricsName_RBM)
        for row in TABLE:
            csvWriter.writerow(row)

        f.close()
        

        f = open("./heatmap_data/{0}/{1}/normal_{2}.csv".format(feature_reduction, projectName, file_name),'w')
        csvWriter = csv.writer(f)

        csvWriter.writerow(metricsName_RBM)
        for row in TABLE_normal:
            csvWriter.writerow(row)

        f.close()
        


for feature_reduction in FEATURE_REDUCTIONS:

    for csvName, projectName in zip(CSVName, PROJECTNAME):

        cal_main(feature_reduction,csvName,projectName)
