import csv
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from collections import OrderedDict

disp_models = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+']

def read():
    f = open('./quantile/RQ1_quantile.txt')
    reader = csv.reader(f)

    head = next(reader)
    head = head[0].split()

    data = []
    for row in reader:
        temp = []
        q = row[0].split()

        for d_name in disp_models:
            temp.append(q[head.index(d_name)+1])

        data.append(temp)
    return data

def make_table(data):

    TABLE = []
    for row in data:
        temp = []
        for num in row:
            temp.append('%03.4f' % round(float(num),4))
        temp[-1] = '{0}\\\\'.format(temp[-1])
        TABLE.append(temp)

    TABLE = pd.DataFrame(TABLE,columns=disp_models,index=['0\\%','25\\%','50\\%','75\\%','100\\%'])
    TABLE.to_csv(path_or_buf='./quantile/RQ1_quantile.csv',sep="&")


if __name__=='__main__':
    data = read()
    make_table(data)
