import csv
import numpy as np

#representation = "mean"
representation = "median"

Directory = ["unsupervised_FA","unsupervised"]

#FileName = [['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3'],['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],['eclipse','equinox','lucene','mylyn','pde']]
#ProjectName = ['PROMISE','NASA','AEEEM']
FileName = [['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3'],['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],['eclipse','equinox','lucene','mylyn','pde']]
ProjectName = ['PROMISE','NASA','AEEEM']



for directory in Directory:
    for fileName,projectName in zip(FileName,ProjectName):

        if directory == "unsupervised":
            MachineLearning = ['PRE_SC', 'PRE_PAM', 'PRE_NG', 'PRE_FCM', 'PRE_KM']
        elif directory == "unsupervised_FA":
            MachineLearning = ['FA_SC', 'FA_PAM', 'FA_NG', 'FA_FCM', 'FA_KM']

        SC = []
        PAM = []
        NG = []
        FCM = []
        KM = []

        List = [SC, PAM, NG, FCM, KM]

        for f_name in fileName:

            if directory == "unsupervised":
                f = open("./../PRE/data/{0}/{1}_1_100.csv".format(projectName, f_name))
                #f = open("./../../../../outputs/FR_USVL/PRE/data/{0}/{1}.csv".format(projectName, f_name))
            elif directory == "unsupervised_FA":
                f = open("./../FeatureAgglomeration/data/{0}/{1}_1_101.csv".format(projectName, f_name))
                #f = open("./../../../../outputs/FR_USVL/FeatureAgglomeration/data/{0}/{1}.csv".format(projectName, f_name))


            reader = csv.reader(f)

            for row, l in zip(reader, List):
                row = list(map(float, row))
                try :
                    if representation == "mean":
                        l.append(sum(row)/len(row))
                        #print(sum(row)/len(row))
                    if representation == "median":
                        l.append(np.median(np.array(row)))
                        #print(np.median(np.array(row)))
                except ZeroDivisionError:
                    print(f_name)

        f.close()

        if directory == "unsupervised":
            f = open("./RQ4/PRE_{0}_{1}_Unsuper.txt".format(representation,projectName),'w')
        elif directory == "unsupervised_FA":
            f = open("./RQ4/FA_{0}_{1}_Unsuper.txt".format(representation,projectName),'w')
        #f = open("./FA_mean_PROMISE_Unsuper.txt".format(representation,projectName),'w')

        writer = csv.writer(f)
        writer.writerow(["group    score"])

        for l, name in zip(List, MachineLearning):
            for i in l:
                writer.writerow(["{0}  {1}".format(name,i)])

        f.close()
