#-*- coding: utf-8 -*-
import numpy as np
import csv
import pyper
import sys
import gc
sys.path.append("./../Util/")

import preparation
import clustering
import evaluation
import FS

csvName = ['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5']
projectName = 'NASA'

PARA = sys.argv

def data_extend(filename):
    train_data = []
    train_target = []

    f = open(filename,'r')
    dataReader = csv.reader(f)
    for row in dataReader:
        train_data.append(list(map(float,row[:-1])))
        train_target.append(row[-1])

    f.close()

    train_data = np.array(train_data)

    temp = []
    for i in train_target:
        if i == 'Y' or i=='TRUE':
            temp.append(1)
        elif i=='N' or i=='FALSE':
            temp.append(0)
        else:
            print('error')

    train_target = temp

    train_target = np.array(temp)

    return [train_data, train_target]


def cal_10_fold_CV_PROMISE(csvName,projectName):
    ALL = {}

    r = pyper.R()
    r("set.seed(200)")

    r('library("caret")')
    r('library("FSelector")')

    for file_name in csvName:
        ALL[file_name] = []
        count = 0
        all_count = 0

        LMT = [] # Logistic Model Tree
        J48 = [] # Decision Tree (J48)
        LR = [] # Logistic Regression
        NB = [] # Naive Bayes
        RF = [] # Random Forest

        CFS_feature_data_list = []

        for times in range(int(PARA[1]),int(PARA[2])+1):

            print("+++ {0} times {1} fold +++".format(times,file_name))

            train_data = []
            train_target = []
            test_data = []
            test_target = []

            filename = "./../../data/{0}/{1}/train_times{2}.csv".format(projectName, file_name, times)
            train_data, train_target = data_extend(filename)

            filename = "./../../data/{0}/{1}/test_times{2}.csv".format(projectName, file_name, times)
            test_data, test_target = data_extend(filename)


            if sum(train_target)==0 or sum(train_target)==len(train_target):
                all_count = all_count + 1
                print("---train data error---")
                sys.exit()

            if sum(test_target)==0 or sum(test_target)==len(train_target):
                all_count = all_count + 1
                print("---train data error---")
                sys.exit()


            train_data_std, test_data_std = preparation.standardization_SVL(train_data,test_data,"z-score")

            train_data_std, test_data_std = FS.CFS(train_data_std, train_target, test_data_std, r)

            CFS_feature_data_list.append(test_data_std)


            #ans = cslLMTbyR(train_data_std)
            ans_LMT,ans_J48,ans_NB,ans_RF,ans_LR = clustering.Caret(train_data_std,train_target,test_data_std,test_target,r)


            #print('Conventional with LMT')
            temp = evaluation.calAUC_SVL(ans_LMT,test_target)
            #print(temp)
            LMT.append(temp)


            temp = evaluation.calAUC_SVL(ans_J48,test_target)
            #print(temp)
            J48.append(temp)


            temp = evaluation.calAUC_SVL(ans_NB,test_target)
            #print(temp)
            NB.append(temp)


            temp = evaluation.calAUC_SVL(ans_RF,test_target)
            #print(temp)
            RF.append(temp)


            temp = evaluation.calAUC_SVL(ans_LR,test_target)
            #print(temp)
            LR.append(temp)


            del train_data
            del train_target
            del train_data_std
            del test_data
            del test_target
            del test_data_std
            gc.collect()


        ALL[file_name].append(LMT)
        ALL[file_name].append(J48)
        ALL[file_name].append(LR)
        ALL[file_name].append(NB)
        ALL[file_name].append(RF)


        print(" --- result of {0} average --- ".format(file_name))
        print("LMT : {0}".format(sum(ALL[file_name][0])/len(ALL[file_name][0])))
        print("J48 : {0}".format(sum(ALL[file_name][1])/len(ALL[file_name][1])))
        print("LR : {0}".format(sum(ALL[file_name][2])/len(ALL[file_name][2])))
        print("NB : {0}".format(sum(ALL[file_name][3])/len(ALL[file_name][3])))
        print("RF : {0}".format(sum(ALL[file_name][4])/len(ALL[file_name][4])))

        
        f = open('./data/{1}/{0}_{2}_{3}.csv'.format(file_name,projectName,PARA[1],PARA[2]),'w')
        csvWriter = csv.writer(f)

        for metrics in ALL[file_name]:
            csvWriter.writerow(metrics)


        f = open('./data/NASA/{0}_metrics_{1}_{2}.csv'.format(file_name,PARA[1],PARA[2]),'w')
        csvWriter = csv.writer(f)

        for metrics in CFS_feature_data_list:
            for metric in metrics:
                csvWriter.writerow(metric)

            csvWriter.writerow("")




cal_10_fold_CV_PROMISE(csvName,projectName)
