#-*- coding: utf-8 -*-
import numpy as np
import csv
import pyper
import sys
import gc
sys.path.append("./../Util/")

import preparation
import clustering
import evaluation
import FS

csvName = ['eclipse','equinox','lucene','mylyn','pde']
projectName = 'AEEEM'
metricsName = ['bug-metrics','change-metrics','complexity-code-change','single-version-ck-oo','churn','exp-churn','lin-churn','log-churn','weighted-churn','ent','exp-ent','lin-ent','log-ent','weighted-ent']

PARA = sys.argv

def data_extend(filename,filename2,filename3,p_name,times):
    train_data = []
    train_target = []


    f1 = open(filename.format(p_name,metricsName[0],times),'r')
    f2 = open(filename.format(p_name,metricsName[1],times),'r')
    f3 = open(filename.format(p_name,metricsName[2],times),'r')
    f4 = open(filename.format(p_name,metricsName[3],times),'r')
    f5 = open(filename2.format(p_name,metricsName[4],times),'r')
    f6 = open(filename2.format(p_name,metricsName[5],times),'r')
    f7 = open(filename2.format(p_name,metricsName[6],times),'r')
    f8 = open(filename2.format(p_name,metricsName[7],times),'r')
    f9 = open(filename2.format(p_name,metricsName[8],times),'r')
    f10 = open(filename3.format(p_name,metricsName[9],times),'r')
    f11 = open(filename3.format(p_name,metricsName[10],times),'r')
    f12 = open(filename3.format(p_name,metricsName[11],times),'r')
    f13 = open(filename3.format(p_name,metricsName[12],times),'r')
    f14 = open(filename3.format(p_name,metricsName[13],times),'r')
    dataReader1 = csv.reader(f1)
    dataReader2 = csv.reader(f2)
    dataReader3 = csv.reader(f3)
    dataReader4 = csv.reader(f4)
    dataReader5 = csv.reader(f5)
    dataReader6 = csv.reader(f6)
    dataReader7 = csv.reader(f7)
    dataReader8 = csv.reader(f8)
    dataReader9 = csv.reader(f9)
    dataReader10 = csv.reader(f10)
    dataReader11 = csv.reader(f11)
    dataReader12 = csv.reader(f12)
    dataReader13 = csv.reader(f13)
    dataReader14 = csv.reader(f14)
    for row1,row2,row3,row4,row5,row6,row7,row8,row9,row10,row11,row12,row13,row14 in zip(dataReader1,dataReader2,dataReader3,dataReader4,dataReader5,dataReader6,dataReader7,dataReader8,dataReader9,dataReader10,dataReader11,dataReader12,dataReader13,dataReader14):
        temp = []
        temp.extend(list(map(float,row1[1:6])))
        temp.extend(list(map(float,row2[1:16])))
        temp.extend(list(map(float,row3[1:6])))
        temp.extend(list(map(float,row4[1:18])))
        temp.extend(list(map(float,row5[1:18])))
        temp.extend(list(map(float,row6[1:18])))
        temp.extend(list(map(float,row7[1:18])))
        temp.extend(list(map(float,row8[1:18])))
        temp.extend(list(map(float,row9[1:18])))
        temp.extend(list(map(float,row10[1:18])))
        temp.extend(list(map(float,row11[1:18])))
        temp.extend(list(map(float,row12[1:18])))
        temp.extend(list(map(float,row13[1:18])))
        temp.extend(list(map(float,row14[1:18])))

        train_data.append(temp)
        train_target.append(float(row4[18]))

    f1.close()
    f2.close()
    f3.close()
    f4.close()
    f5.close()
    f6.close()
    f7.close()
    f8.close()
    f9.close()
    f10.close()
    f11.close()
    f12.close()
    f13.close()
    f14.close()

    train_data = np.array(train_data)

    temp = []
    for i in train_target:
        if i != 0:
            temp.append(1)
        else:
            temp.append(0)

    train_target = np.array(temp)

    return [train_data, train_target]


def cal_10_fold_CV_PROMISE(projectName,metricsName):
    ALL = {}

    r = pyper.R()
    r("set.seed(200)")

    r('library("caret")')
    r('library("FSelector")')

    for file_name in csvName:
        ALL[file_name] = []
        count = 0
        all_count = 0

        LMT = [] # Logistic Model Tree
        J48 = [] # Decision Tree (J48)
        LR = [] # Logistic Regression
        NB = [] # Naive Bayes
        RF = [] # Random Forest

        ConFS_feature_data_list = []

        for times in range(int(PARA[1]),int(PARA[2])+1):


            print("+++ {0} times {1} fold +++".format(times,file_name))

            train_data = []
            train_target = []
            test_data = []
            test_target = []

            filename = "./../../data/AEEEM/{0}/{1}/train_times{2}.csv"
            filename2 = "./../../data/AEEEM/{0}/churn/{1}/train_times{2}.csv"
            filename3 = "./../../data/AEEEM/{0}/entropy/{1}/train_times{2}.csv"

            train_data, train_target = data_extend(filename,filename2,filename3,file_name,times)


            filename = "./../../data/AEEEM/{0}/{1}/test_times{2}.csv"
            filename2 = "./../../data/AEEEM/{0}/churn/{1}/test_times{2}.csv"
            filename3 = "./../../data/AEEEM/{0}/entropy/{1}/test_times{2}.csv"
            test_data, test_target = data_extend(filename,filename2,filename3,file_name,times)


            if sum(train_target)==0 or sum(train_target)==len(train_target):
                all_count = all_count + 1
                print("---train data error---")
                sys.exit()

            if sum(test_target)==0 or sum(test_target)==len(train_target):
                all_count = all_count + 1
                print("---train data error---")
                sys.exit()


            train_data_std, test_data_std = preparation.standardization_SVL(train_data,test_data,"z-score")

            train_data_std, test_data_std = FS.ConFS(train_data_std, train_target, test_data_std, r)

            ConFS_feature_data_list.append(test_data_std)


            #ans = cslLMTbyR(train_data_std)
            ans_LMT,ans_J48,ans_NB,ans_RF,ans_LR = clustering.Caret(train_data_std,train_target,test_data_std,test_target,r)


            #print('Conventional with LMT')
            temp = evaluation.calAUC_SVL(ans_LMT,test_target)
            #print(temp)
            LMT.append(temp)


            temp = evaluation.calAUC_SVL(ans_J48,test_target)
            #print(temp)
            J48.append(temp)


            temp = evaluation.calAUC_SVL(ans_NB,test_target)
            #print(temp)
            NB.append(temp)


            temp = evaluation.calAUC_SVL(ans_RF,test_target)
            #print(temp)
            RF.append(temp)


            temp = evaluation.calAUC_SVL(ans_LR,test_target)
            #print(temp)
            LR.append(temp)


            del train_data
            del train_target
            del train_data_std
            del test_data
            del test_target
            del test_data_std
            gc.collect()


        ALL[file_name].append(LMT)
        ALL[file_name].append(J48)
        ALL[file_name].append(LR)
        ALL[file_name].append(NB)
        ALL[file_name].append(RF)

        print(" --- result of {0} average --- ".format(file_name))
        print("LMT : {0}".format(sum(ALL[file_name][0])/len(ALL[file_name][0])))
        print("J48 : {0}".format(sum(ALL[file_name][1])/len(ALL[file_name][1])))
        print("LR : {0}".format(sum(ALL[file_name][2])/len(ALL[file_name][2])))
        print("NB : {0}".format(sum(ALL[file_name][3])/len(ALL[file_name][3])))
        print("RF : {0}".format(sum(ALL[file_name][4])/len(ALL[file_name][4])))

        
        #f = open('./data/{1}/{0}.csv'.format(name,projectName),'w')
        f = open('./data/{1}/{0}_{2}_{3}.csv'.format(file_name,projectName,PARA[1],PARA[2]),'w')
        csvWriter = csv.writer(f)

        for metrics in ALL[file_name]:
            csvWriter.writerow(metrics)


        f = open('./data/AEEEM/{0}_metrics_{1}_{2}.csv'.format(file_name,PARA[1],PARA[2]),'w')
        csvWriter = csv.writer(f)

        for metrics in ConFS_feature_data_list:
            for metric in metrics:
                csvWriter.writerow(metric)

            csvWriter.writerow("")


cal_10_fold_CV_PROMISE(projectName,metricsName)


