import numpy as np


def CFS(train_data_std, train_target, test_data_std, r):
    r.assign("train_data",train_data_std)
    r.assign("test_data",test_data_std)
    r.assign("train_target",train_target)

    r('temp <- c(train_target!=0)')
    r('temp <- gsub(TRUE,"Class1",temp)')
    r('temp <- gsub(FALSE,"Class2",temp)')
    r('train_target <- as.factor(temp)')

    r('train_data=as.data.frame(train_data)')
    r('test_data=as.data.frame(test_data)')
    r('train_data=cbind(train_data,train_target)')

    r('subset <- cfs(train_target~.,data=train_data)')
    r('new_train_data <- as.matrix(train_data[,subset])')
    r('new_test_data <- as.matrix(test_data[,subset])')
    new_train_data_std = np.array(r.get('new_train_data'))
    new_test_data_std = np.array(r.get('new_test_data'))

    r('temp = NaN')
    r('train_data = NaN')
    r('test_data = NaN')
    r('train_target = NaN')
    r('subset = NaN')
    r('new_train_data = NaN')
    r('new_test_data = NaN')

    return new_train_data_std, new_test_data_std


def ConFS(train_data_std, train_target, test_data_std, r):
    r.assign("train_data",train_data_std)
    r.assign("test_data",test_data_std)
    r.assign("train_target",train_target)

    r('temp <- c(train_target!=0)')
    r('temp <- gsub(TRUE,"Class1",temp)')
    r('temp <- gsub(FALSE,"Class2",temp)')
    r('train_target <- as.factor(temp)')

    r('train_data=as.data.frame(train_data)')
    r('test_data=as.data.frame(test_data)')
    r('train_data=cbind(train_data,train_target)')

    r('subset <- consistency(train_target~.,data=train_data)')
    r('new_train_data <- as.matrix(train_data[,subset])')
    r('new_test_data <- as.matrix(test_data[,subset])')
    new_train_data_std = np.array(r.get('new_train_data'))
    new_test_data_std = np.array(r.get('new_test_data'))

    r('temp = NaN')
    r('train_data = NaN')
    r('test_data = NaN')
    r('train_target = NaN')
    r('subset = NaN')
    r('new_train_data = NaN')
    r('new_test_data = NaN')

    return new_train_data_std, new_test_data_std
