spectral_clustering_based_classifier <- function(A) {
        # Normalize software metrics.
        normA = apply(A, 2, function(x){(x-mean(x))/sd(x)})
        #normA = A
        # Construct the weighted adjacency matrix W.
        W = normA %*% t(normA)
        # Set all negative values to zero.
        W[W<0] = 0
        # Set the self-similarity to zero.
        W = W - diag(diag(W))
        # Construct the symmetric Laplacian matrix Lsym. 
        Dnsqrt = diag(1/sqrt(rowSums(W)))
        I = diag(rep(1, nrow(W)))
        Lsym = I - Dnsqrt %*% W %*% Dnsqrt
        # Perform the eigendecomposition.
        ret_egn = eigen(Lsym, symmetric=TRUE)
        # Pick up the second smallest eigenvector.
        v1 = Dnsqrt %*% ret_egn$vectors[, nrow(W)-1] 
        v1 = v1 / sqrt(sum(v1^2))

        metrics <- data.frame(v1,v1)
        metrics <- as.matrix(metrics)
        library(cclust)
        ans <- cclust(metrics,centers=2,method='kmeans')
        defect_proneness <- ans$cluster
        
        defect_proneness
}
