import csv
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt

ProjectName = {"PROMISE":['ant v1.7','camel v1.6','ivy v1.4','jedit v4.0','log4j v1.0','lucene v2.4','poi v3.0','tomcat v6.0','xalan v2.6','xerces v1.3'],"NASA":['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],"AEEEM":['Eclipse JDT Core','Equinox','Apache Lucene','Mylyn','Eclipse PDE UI']}

DatasetName = ['PROMISE','NASA','AEEEM']
#DatasetName = ['AEEEM']

Write_Name = ["RQ3_table_PROMISE.csv","RQ3_table_NASA.csv","RQ3_table_AEEEM.csv"]

TECH = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+']
NUM = [2,1,5,3,4,6,7,8]

TECH_OUTPUT = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+','ORG']
#TECH_OUTPUT = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+','PRE']


def read_data():

    LMT = {}
    J48 = {}
    LR = {}
    NB = {}
    RF = {}
    conventional_LMT = {}
    conventional_J48 = {}
    conventional_LR = {}
    conventional_NB = {}
    conventional_RF = {}

    for d_name in DatasetName:
        LMT['{0}'.format(d_name)] = {}
        J48['{0}'.format(d_name)] = {}
        LR['{0}'.format(d_name)] = {}
        NB['{0}'.format(d_name)] = {}
        RF['{0}'.format(d_name)] = {}
        for num, tech in zip(NUM,TECH):

            f = open('./../FR_SVL/test/RQ{0}/{1}_median_{2}_Super.txt'.format(num,tech,d_name))
            reader = f.readlines()

            LMT['{0}'.format(d_name)]['{0}'.format(tech)] = []
            J48['{0}'.format(d_name)]['{0}'.format(tech)] = []
            LR['{0}'.format(d_name)]['{0}'.format(tech)] = []
            NB['{0}'.format(d_name)]['{0}'.format(tech)] = []
            RF['{0}'.format(d_name)]['{0}'.format(tech)] = []


            for row in reader:
                text = row.replace('\n','').split("  ")
                #print(text)

                if text[0]=='{0}_LMT'.format(tech):
                    LMT['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_J48'.format(tech):
                    J48['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_LR'.format(tech):
                    LR['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_NB'.format(tech):
                    NB['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_RF'.format(tech):
                    RF['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                else:
                    pass

            f.close()


        f = open('./../FR_SVL/test/RQ1/PRE_median_{0}_Super.txt'.format(d_name),'r')
        reader = f.readlines()

        conventional_LMT['{0}'.format(d_name)] = []
        conventional_J48['{0}'.format(d_name)] = []
        conventional_LR['{0}'.format(d_name)] = []
        conventional_NB['{0}'.format(d_name)] = []
        conventional_RF['{0}'.format(d_name)] = []
        for row in reader:
            text = row.replace('\n','').split("  ")
            #print(text)

            if text[0]=='PRE_LMT':
                conventional_LMT['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_J48':
                conventional_J48['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_LR':
                conventional_LR['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_NB':
                conventional_NB['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_RF':
                conventional_RF['{0}'.format(d_name)].append(float(text[1]))
            else:
                pass

        f.close()


    TABLE = {}
    for tech in TECH:

        TABLE[tech] = {}

        for d_name in DatasetName:

            TABLE[tech][d_name] = {}

            cnt = 0
            for a,b,c,d,e in zip(LMT[d_name][tech],J48[d_name][tech],LR[d_name][tech],NB[d_name][tech],RF[d_name][tech]):

                TABLE[tech][d_name][ProjectName[d_name][cnt]] = [a,b,c,d,e]

                cnt += 1

    tech = 'ORG'
    TABLE[tech] = {}

    for d_name in DatasetName:
        TABLE[tech][d_name] = {}

        cnt = 0
        for a,b,c,d,e in zip(conventional_LMT['{0}'.format(d_name)],conventional_J48['{0}'.format(d_name)],conventional_LR['{0}'.format(d_name)],conventional_NB['{0}'.format(d_name)],conventional_RF['{0}'.format(d_name)]):

            TABLE[tech][d_name][ProjectName[d_name][cnt]] = [a,b,c,d,e]
            cnt += 1

    #print(TABLE)


    for d_name in DatasetName:
        for cnt in range(len(ProjectName[d_name])):

            temp = []
            for tech in TECH:

                temp.append(TABLE[tech][d_name][ProjectName[d_name][cnt]])
            #print('tech: {0}, database: {1}, project: {2}'.format(tech,d_name,ProjectName[d_name][cnt]))
            #print(TABLE[tech][d_name][ProjectName[d_name][cnt]])
            temp.append(TABLE['ORG'][d_name][ProjectName[d_name][cnt]])

            temp = np.array(temp).T

            #f = open('./SVL_data/{0}_{1}.csv'.format(d_name,ProjectName[d_name][cnt]),'w')
            f = open('./performance_data/RQ1_SVL_{0}_{1}.csv'.format(d_name,ProjectName[d_name][cnt]),'w')
            csvWriter = csv.writer(f)

            csvWriter.writerow(TECH_OUTPUT)

            for row in temp:
                csvWriter.writerow(row)


read_data()




