import csv
import numpy as np
import sys

METHODS = ['AE','RBM','FM','FA','PCA','RP','TCA','TCA+','CFS','ConFS','PRE']
OUTPUT = ['AE','RBM','FM','FA','PCA','RP','TCA','TCA+','CFS','ConFS','ORG']
TYPE = ['USVL','SVL']
PROJECTS = ['PROMISE','NASA','AEEEM']


def read_data(m_name, p_name, t_name):

    temp = []

    if t_name == 'USVL':
        if m_name == 'TCA+':
            f = open('./../../FR_USVL/test/RQ{0}/TCA+_median_{1}_Unsuper.txt'.format(METHODS.index(m_name)+1,p_name),'r')
        elif m_name == 'PRE':
            f = open('./../../FR_USVL/test/RQ1/PRE_median_{0}_Unsuper.txt'.format(p_name),'r')
        elif m_name in ['CFS','ConFS']:
            f = open('./../USVL/test/RQ{0}/{1}_median_{2}_Unsuper.txt'.format(METHODS.index(m_name)+1,m_name,p_name),'r')
        else:
            f = open('./../../FR_USVL/test/RQ{0}/{1}_median_{2}_Unsuper.txt'.format(METHODS.index(m_name)+1,m_name,p_name),'r')
    elif t_name == 'SVL':
        if m_name == 'TCA+':
            f = open('./../../FR_SVL/test/RQ{0}/TCA+_median_{1}_Super.txt'.format(METHODS.index(m_name)+1,p_name),'r')
        elif m_name == 'PRE':
            f = open('./../../FR_SVL/test/RQ1/PRE_median_{0}_Super.txt'.format(p_name),'r')
        elif m_name in ['CFS','ConFS']:
            f = open('./../SVL/test/RQ{0}/{1}_median_{2}_Super.txt'.format(METHODS.index(m_name)+1,m_name,p_name),'r')
        else:
            f = open('./../../FR_SVL/test/RQ{0}/{1}_median_{2}_Super.txt'.format(METHODS.index(m_name)+1,m_name,p_name),'r')
    else:
        print('READ DATA ERROR')
        sys.exit()

    reader = csv.reader(f)
    next(reader)

    for row in reader:
        temp.append(row[0].split(' ')[-1].replace('\n',''))

    temp = list(map(float,temp))


    return temp





def main():

    results = {}

    for t_name in TYPE:
        results[t_name] = {}
        for m_name in METHODS:
            results[t_name][m_name] = []

            for p_name in PROJECTS:

                results[t_name][m_name].extend(read_data(m_name, p_name, t_name))

    
    TABLE = []
    for t_name in TYPE:
        for m_name, o_m_name in zip(METHODS,OUTPUT):
            results[t_name][m_name].insert(0,'{0}_{1}'.format(t_name,o_m_name))
            TABLE.append(results[t_name][m_name])

    TABLE = np.array(TABLE).T

    #print(TABLE)

    f = open('./performance_data/RQ3_data_ESD.csv','w')
    csvWriter = csv.writer(f)

    for row in TABLE:
        csvWriter.writerow(row)



main()
