import csv
import numpy as np
import pandas as pd

ProjectName = {"PROMISE":['ant v1.7','camel v1.6','ivy v1.4','jedit v4.0','log4j v1.0','lucene v2.4','poi v3.0','tomcat v6.0','xalan v2.6','xerces v1.3'],"NASA":['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5'],"AEEEM":['Eclipse JDT Core','Equinox','Apache Lucene','Mylyn','Eclipse PDE UI']}

DatasetName = ['PROMISE','NASA','AEEEM']
#DatasetName = ['AEEEM']
#DatasetName = ['PROMISE']

Write_Name = ["RQ3_table_PROMISE.csv","RQ3_table_NASA.csv","RQ3_table_AEEEM.csv"]

TECH = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+','CFS','ConFS']
NUM = [2,1,5,3,4,6,7,8,9,10]

TECH_OUTPUT = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+','CFS','ConFS','ORG']
#TECH_OUTPUT = ['RBM','AE','PCA','FM','FA','RP','TCA','TCA+','PRE']


def read_data():

    SC = {}
    PAM = {}
    NG = {}
    FCM = {}
    KM = {}
    conventional_SC = {}
    conventional_PAM = {}
    conventional_NG = {}
    conventional_FCM = {}
    conventional_KM = {}

    for d_name in DatasetName:
        SC['{0}'.format(d_name)] = {}
        PAM['{0}'.format(d_name)] = {}
        NG['{0}'.format(d_name)] = {}
        FCM['{0}'.format(d_name)] = {}
        KM['{0}'.format(d_name)] = {}
        for num, tech in zip(NUM,TECH):

            if tech in ['CFS','ConFS']:
                f = open('./../USVL/test/RQ{0}/{1}_median_{2}_Unsuper.txt'.format(num,tech,d_name))
            else:
                f = open('./../../FR_USVL/test/RQ{0}/{1}_median_{2}_Unsuper.txt'.format(num,tech,d_name))
            reader = f.readlines()

            SC['{0}'.format(d_name)]['{0}'.format(tech)] = []
            PAM['{0}'.format(d_name)]['{0}'.format(tech)] = []
            NG['{0}'.format(d_name)]['{0}'.format(tech)] = []
            FCM['{0}'.format(d_name)]['{0}'.format(tech)] = []
            KM['{0}'.format(d_name)]['{0}'.format(tech)] = []


            for row in reader:
                text = row.replace('\n','').split("  ")
                #print(text)

                if text[0]=='{0}_SC'.format(tech):
                    SC['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_PAM'.format(tech):
                    PAM['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_NG'.format(tech):
                    NG['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_FCM'.format(tech):
                    FCM['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                elif text[0]=='{0}_KM'.format(tech):
                    KM['{0}'.format(d_name)]['{0}'.format(tech)].append(float(text[1]))
                else:
                    pass

            f.close()


        f = open('./../../FR_USVL/test/RQ1/PRE_median_{0}_Unsuper.txt'.format(d_name),'r')
        reader = f.readlines()

        conventional_SC['{0}'.format(d_name)] = []
        conventional_PAM['{0}'.format(d_name)] = []
        conventional_NG['{0}'.format(d_name)] = []
        conventional_FCM['{0}'.format(d_name)] = []
        conventional_KM['{0}'.format(d_name)] = []
        for row in reader:
            text = row.replace('\n','').split("  ")
            #print(text)

            if text[0]=='PRE_SC':
                conventional_SC['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_PAM':
                conventional_PAM['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_NG':
                conventional_NG['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_FCM':
                conventional_FCM['{0}'.format(d_name)].append(float(text[1]))
            elif text[0]=='PRE_KM':
                conventional_KM['{0}'.format(d_name)].append(float(text[1]))
            else:
                pass

        f.close()


    TABLE = {}
    for tech in TECH:

        TABLE[tech] = {}

        for d_name in DatasetName:

            TABLE[tech][d_name] = {}

            cnt = 0
            for a,b,c,d,e in zip(SC[d_name][tech],PAM[d_name][tech],NG[d_name][tech],FCM[d_name][tech],KM[d_name][tech]):

                TABLE[tech][d_name][ProjectName[d_name][cnt]] = [a,b,c,d,e]

                cnt += 1

    tech = 'ORG'
    TABLE[tech] = {}

    for d_name in DatasetName:
        TABLE[tech][d_name] = {}

        cnt = 0
        for a,b,c,d,e in zip(conventional_SC['{0}'.format(d_name)],conventional_PAM['{0}'.format(d_name)],conventional_NG['{0}'.format(d_name)],conventional_FCM['{0}'.format(d_name)],conventional_KM['{0}'.format(d_name)]):

            TABLE[tech][d_name][ProjectName[d_name][cnt]] = [a,b,c,d,e]
            cnt += 1

    #print(TABLE)


    for d_name in DatasetName:
        for cnt in range(len(ProjectName[d_name])):

            temp = []
            for tech in TECH:

                temp.append(TABLE[tech][d_name][ProjectName[d_name][cnt]])
            #print('tech: {0}, database: {1}, project: {2}'.format(tech,d_name,ProjectName[d_name][cnt]))
            #print(TABLE[tech][d_name][ProjectName[d_name][cnt]])
            temp.append(TABLE['ORG'][d_name][ProjectName[d_name][cnt]])

            temp = np.array(temp).T

            f = open('./performance_data/RQ3_USVL_{0}_{1}.csv'.format(d_name,ProjectName[d_name][cnt]),'w')
            csvWriter = csv.writer(f)

            csvWriter.writerow(TECH_OUTPUT)

            for row in temp:
                csvWriter.writerow(row)

read_data()




