import csv
import numpy as np

METHODS = ['AE','RBM','FM','FA','PCA','RP','TCA','TCA+','CFS','ConFS','PRE']
OUTPUT = ['AE','RBM','FM','FA','PCA','RP','TCA','TCA+','CFS','ConFS','ORG']
PROJECTS = ['PROMISE','NASA','AEEEM']


def read_data(m_name, p_name):

    temp = []

    if m_name == 'TCA+':
        f = open('./RQ{0}/TCA+_median_{1}_Super.txt'.format(METHODS.index(m_name)+1,p_name),'r')
    elif m_name == 'PRE':
        f = open('./RQ1/PRE_median_{0}_Super.txt'.format(p_name),'r')
    else:
        f = open('./RQ{0}/{1}_median_{2}_Super.txt'.format(METHODS.index(m_name)+1,m_name,p_name),'r')
    reader = csv.reader(f)
    next(reader)

    for row in reader:
        temp.append(row[0].split(' ')[-1].replace('\n',''))

    temp = list(map(float,temp))


    return temp





def main():

    results = {}

    for m_name in METHODS:
        results[m_name] = []

        for p_name in PROJECTS:

            results[m_name].extend(read_data(m_name, p_name))

    
    TABLE = []
    for m_name, o_m_name in zip(METHODS,OUTPUT):
        results[m_name].insert(0,o_m_name)
        TABLE.append(results[m_name])

    TABLE = np.array(TABLE).T

    #print(TABLE)

    f = open('./performance_data/data_ESD.csv','w')
    csvWriter = csv.writer(f)

    for row in TABLE:
        csvWriter.writerow(row)



main()
