#!/bin/sh

cd data/
bash conduct.sh

cd ../

dir=("RBM" "AutoEnco" "FastMap" "FeatureAgglomeration" "PCA" "PRE" "RandomProjection" "TCA" "TCA+")

# for feature reduction to SVL models
cd FR_SVL/
bash mk_data_files.sh
echo "bash mk_data_files.sh"
for d_name in ${dir[@]}; do
    cd $d_name
    bash conduct.sh
    echo "bash conduct.sh"
    cd ./../
done

python3 summarize.py
echo "python3 summarize.py"

cd ./../

echo "============================"

# for feature reduction to USVL
cd FR_USVL/
bash mk_data_files.sh
echo "bash mk_data_files.sh"
for d_name in ${dir[@]}; do
    cd $d_name
    bash conduct.sh
    echo "bash conduct.sh"
    cd ./../
done

python3 summarize.py
echo "python3 summarize.py"

cd ./../

echo "============================"


dir=("CFS" "ConFS")

# for feature selection to SVL
cd FS_SVL/
bash mk_data_files.sh
echo "bash mk_data_files.sh"
for d_name in ${dir[@]}; do
    cd $d_name
    bash conduct.sh
    echo "bash conduct.sh"
    cd ./../
done

cd ./../


echo "============================"


# for feature selection to USVL
cd FS_USVL/
bash mk_data_files.sh
echo "bash mk_data_files.sh"
for d_name in ${dir[@]}; do
    cd $d_name
    bash conduct.sh
    echo "bash conduct.sh"
    cd ./../
done

cd ./../


echo "============================"

# for RQ3

cd RQ3/SVL/
bash mk_data_files.sh
echo "bash mk_data_files.sh"
cd test
bash conduct.sh
echo "conduct.sh"

cd ./../../USVL/
bash mk_data_files.sh
echo "bash mk_data_files.sh"
cd test
bash conduct.sh
echo "conduct.sh"

cd ./../../../


echo "============================"

dir=("RBM" "AE")

# for FR_MetricsAnalysis
cd ./FR_MetricsAnalysis/
bash ./mk_dir.sh
echo "bash mk_dir.sh"

for d_name in ${dir[@]}; do
    cd $d_name
    python3 main_random.py
    echo "python3 main_random.py"

    cd ../
done

cd ../


# ===========================================
# Make the figures and tables in the paper.
# ===========================================


# make Fig 4(a) and Fig 6(a) in performance_plot/ and variance_plot/
cd ./FR_SVL/test/
bash conduct.sh


# make Fig 4(b), Fig 6(b), Table 5, Fig. 7, Fig. 8(a), (b), (d), (e)
# Fig. 9(a), (b), (c), (f), (g) in performance_plot/, variance_plot/
# clustering_plot/, heatmap_plot/, and quantile/.
cd ./../../FR_USVL/test/
bash conduct.sh

# make Fig. 5, R2.10 first figures in performance_plot/.
cd ./../../Figures/
bash conduct.sh

# make R2.10 the first and second tabels in tables/.
cd ./../Tables/
bash conduct.sh

# make Fig. 8 (c), Fig. 9 (d), (e), (h).
cd ./../FR_MetricsAnalysis/
bash mk_dir.sh
cd discussion/
bash conduct.sh


# make E1 the first figure (SVL), the second figure (SVL) in performance_plot/, variance_plot/
cd ./../../RQ3/SVL/
bash mk_data_files.sh
cd test/
bash conduct.sh


# make E1 the first figure (USVL), the second figure (USVL) in performance_plot/, variance_plot/
cd ./../../USVL/
bash mk_data_files.sh
cd test/
bash conduct.sh


# make E1's the median ratios' tables and understandability tables.
cd ./../../Tables
bash conduct.sh

