
import csv
import numpy as np


csvName = ['cm1','jm1','kc3','mc1','mc2','mw1','pc1','pc2','pc3','pc4','pc5']
#csvName = ['cm1']
projectName = 'NASA'


times = 100
#times = 3

np.random.seed(200)

# ===============================
# x: the original data (list, int, array)
# samples: the number of extracted data
# ===============================
def bootstrap(data, samples):

    idx = np.random.randint(data.shape[0], size=samples)
    test_idx = np.array(list(set([x for x in range(data.shape[0])]) - set(idx)))

    resampled_data = data[idx, :]
    test_data = data[test_idx, :]

    return resampled_data, test_data


for p_name in csvName:
    reader = csv.reader(open('./original_data/{0}.csv'.format(p_name)))

    data = []
    for i in reader :
        data.append(i)

    data = np.array(data)

    for i in range(times):
        resampled_data, test_data = bootstrap(data, data.shape[0])


        f = open('./{0}/{1}/train_times{2}.csv'.format(projectName,p_name,i+1),'w')
        writer = csv.writer(f)
        for row in resampled_data:
            writer.writerow(row)
        f.close()

        f = open('./{0}/{1}/test_times{2}.csv'.format(projectName,p_name,i+1),'w')
        writer = csv.writer(f)
        for row in test_data:
            writer.writerow(row)
        f.close()

