
import csv
import numpy as np


csvName = ['ant_v1_7','camel_v1_6','ivy_v1_4','jedit_v4_0','log4j_v1_0','lucene_v2_4','poi_v3_0','tomcat_v6_0','xalan_v2_6','xerces_v1_3']
#csvName = ['ant_v1_7']
projectName = 'PROMISE'


times = 100
#times = 3

np.random.seed(200)

# ===============================
# x: the original data (list, int, array)
# samples: the number of extracted data
# ===============================
def bootstrap(data, samples):

    idx = np.random.randint(data.shape[0], size=samples)
    test_idx = np.array(list(set([x for x in range(data.shape[0])]) - set(idx)))

    resampled_data = data[idx, :]
    test_data = data[test_idx, :]

    return resampled_data, test_data


for p_name in csvName:
    reader = csv.reader(open('./original_data/{0}.csv'.format(p_name)))

    data = []
    for i in reader :
        data.append(i)

    data = np.array(data)

    for i in range(times):
        resampled_data, test_data = bootstrap(data, data.shape[0])


        f = open('./{0}/{1}/train_times{2}.csv'.format(projectName,p_name,i+1),'w')
        writer = csv.writer(f)
        for row in resampled_data:
            writer.writerow(row)
        f.close()


        f = open('./{0}/{1}/test_times{2}.csv'.format(projectName,p_name,i+1),'w')
        writer = csv.writer(f)
        for row in test_data:
            writer.writerow(row)
        f.close()

